#!/usr/bin/env lua
local num = "[-+0-9.Ee]+"
local buffer, section, weightsum, gainsum
function reset()
  buffer = {}
  section = false
  weightsum = 0
  gainsum = 0
end
reset()
for line in io.lines() do
  if section == false then
    print(line)
    if line:match("%- *RADIATION PATTERNS *%-") then section = true end
  else
    local theta, other1, gain1, gain2, gain, other2 = line:match(
      "^( *"..num..")( +"..num..")( +"..num..")( +"..num..")( +"..num..")( .*)$"
    )
    if theta then
      local weight = math.sin(tonumber(theta)/180*math.pi)
      weightsum = weightsum + weight
      gainsum = gainsum + weight * 10^(tonumber(gain)/10)
      buffer[#buffer+1] = { theta, other1, gain1, gain2, gain, other2 }
    elseif #buffer == 0 then
      print(line)
    else
      scale = math.log(gainsum / weightsum, 10) * 10
      for i, entry in ipairs(buffer) do
        for n = 3, 5 do
          local old = entry[n]
          local new = ("%.03f"):format(tonumber(old) - scale)
          while #new < #old do new = " " .. new end
          entry[n] = new
        end
        print(table.concat(entry))
      end
      print(line)
      reset()
    end
  end
end
